diff --git a/rsvg-cairo-clip.c b/rsvg-cairo-clip.c
index d38cf87..f2af3e5 100644
--- a/rsvg-cairo-clip.c
+++ b/rsvg-cairo-clip.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-shapes.c: Draw shapes with cairo
 
@@ -30,7 +31,6 @@
 #include "rsvg-cairo-clip.h"
 #include "rsvg-cairo-render.h"
 #include "rsvg-styles.h"
-#include "rsvg-bpath-util.h"
 #include "rsvg-path.h"
 
 #include <math.h>
@@ -39,69 +39,51 @@
 typedef struct RsvgCairoClipRender RsvgCairoClipRender;
 
 struct RsvgCairoClipRender {
-    RsvgRender super;
-    cairo_t *cr;
+    RsvgCairoRender super;
     RsvgCairoRender *parent;
 };
 
+#define RSVG_CAIRO_CLIP_RENDER(render) (_RSVG_RENDER_CIC ((render), RSVG_RENDER_TYPE_CAIRO_CLIP, RsvgCairoClipRender))
+
 static void
-rsvg_cairo_clip_apply_affine (RsvgCairoClipRender *render, const double affine[6])
+rsvg_cairo_clip_apply_affine (RsvgCairoClipRender *render, cairo_matrix_t *affine)
 {
-	cairo_matrix_t matrix;
-	gboolean nest = render->cr != render->parent->initial_cr;
-
-	cairo_matrix_init (&matrix,
-					   affine[0], affine[1],
-					   affine[2], affine[3],
-					   affine[4] + (nest ? 0 : render->parent->offset_x),
-					   affine[5] + (nest ? 0 : render->parent->offset_y));
-	cairo_set_matrix (render->cr, &matrix);
+    RsvgCairoRender *cairo_render = &render->super;
+    cairo_matrix_t matrix;
+    gboolean nest = cairo_render->cr != cairo_render->initial_cr;
+
+    cairo_matrix_init (&matrix,
+                       affine->xx, affine->yx,
+                       affine->xy, affine->yy,
+                       affine->x0 + (nest ? 0 : render->parent->offset_x),
+                       affine->y0 + (nest ? 0 : render->parent->offset_y));
+    cairo_set_matrix (cairo_render->cr, &matrix);
 }
 
 static void
-rsvg_cairo_clip_render_path (RsvgDrawingCtx * ctx, const RsvgBpathDef * bpath_def)
+rsvg_cairo_clip_render_path (RsvgDrawingCtx * ctx, const cairo_path_t *path)
 {
-    RsvgCairoClipRender *render = (RsvgCairoClipRender *) ctx->render;
-	RsvgState *state = rsvg_state_current (ctx);
+    RsvgCairoClipRender *render = RSVG_CAIRO_CLIP_RENDER (ctx->render);
+    RsvgCairoRender *cairo_render = &render->super;
+    RsvgState *state = rsvg_current_state (ctx);
     cairo_t *cr;
-    RsvgBpath *bpath;
-    int i;
-
-    cr = render->cr;
-
-	rsvg_cairo_clip_apply_affine (render, state->affine);
-
-    if (rsvg_state_current (ctx)->clip_rule == FILL_RULE_EVENODD)
-        cairo_set_fill_rule (((RsvgCairoRender *) ctx->render)->cr, CAIRO_FILL_RULE_EVEN_ODD);
-    else                        /* state->fill_rule == FILL_RULE_NONZERO */
-        cairo_set_fill_rule (((RsvgCairoRender *) ctx->render)->cr, CAIRO_FILL_RULE_WINDING);
-
-    for (i = 0; i < bpath_def->n_bpath; i++) {
-        bpath = &bpath_def->bpath[i];
-
-        switch (bpath->code) {
-        case RSVG_MOVETO:
-            cairo_close_path (cr);
-            /* fall-through */
-        case RSVG_MOVETO_OPEN:
-            cairo_move_to (cr, bpath->x3, bpath->y3);
-            break;
-        case RSVG_CURVETO:
-            cairo_curve_to (cr, bpath->x1, bpath->y1, bpath->x2, bpath->y2, bpath->x3, bpath->y3);
-            break;
-        case RSVG_LINETO:
-            cairo_line_to (cr, bpath->x3, bpath->y3);
-            break;
-        case RSVG_END:
-            break;
-        }
-    }
+
+    cr = cairo_render->cr;
+
+    rsvg_cairo_clip_apply_affine (render, &state->affine);
+
+    cairo_set_fill_rule (cr, rsvg_current_state (ctx)->clip_rule);
+
+    cairo_append_path (cr, path);
 }
 
 static void
-rsvg_cairo_clip_render_image (RsvgDrawingCtx * ctx,
-                              const GdkPixbuf * pixbuf,
-                              double pixbuf_x, double pixbuf_y, double w, double h)
+rsvg_cairo_clip_render_surface (RsvgDrawingCtx *ctx,
+                                cairo_surface_t *surface,
+                                double src_x,
+                                double src_y, 
+                                double w, 
+                                double h)
 {
 }
 
@@ -109,8 +91,9 @@ rsvg_cairo_clip_render_image (RsvgDrawingCtx * ctx,
 static void
 rsvg_cairo_clip_render_free (RsvgRender * self)
 {
-    RsvgCairoClipRender *me = (RsvgCairoClipRender *) self;
-    g_free (me);
+    RsvgCairoClipRender *clip_render = RSVG_CAIRO_CLIP_RENDER (self);
+
+    g_free (clip_render);
 }
 
 static void
@@ -131,41 +114,49 @@ rsvg_cairo_clip_add_clipping_rect (RsvgDrawingCtx * ctx, double x, double y, dou
 static RsvgRender *
 rsvg_cairo_clip_render_new (cairo_t * cr, RsvgCairoRender *parent)
 {
-    RsvgCairoClipRender *cairo_render = g_new0 (RsvgCairoClipRender, 1);
-
-    cairo_render->super.free = rsvg_cairo_clip_render_free;
-    cairo_render->super.render_image = rsvg_cairo_clip_render_image;
-    cairo_render->super.render_path = rsvg_cairo_clip_render_path;
-    cairo_render->super.pop_discrete_layer = rsvg_cairo_clip_pop_discrete_layer;
-    cairo_render->super.push_discrete_layer = rsvg_cairo_clip_push_discrete_layer;
-    cairo_render->super.add_clipping_rect = rsvg_cairo_clip_add_clipping_rect;
-    cairo_render->super.get_image_of_node = NULL;
+    RsvgCairoClipRender *clip_render = g_new0 (RsvgCairoClipRender, 1);
+    RsvgCairoRender *cairo_render = &clip_render->super;
+    RsvgRender *render = &cairo_render->super;
+
+    g_assert (parent->super.type == RSVG_RENDER_TYPE_CAIRO);
+
+    render->type = RSVG_RENDER_TYPE_CAIRO_CLIP;
+    render->free = rsvg_cairo_clip_render_free;
+    render->create_pango_context = rsvg_cairo_create_pango_context;
+    render->render_pango_layout = rsvg_cairo_render_pango_layout;
+    render->render_surface = rsvg_cairo_clip_render_surface;
+    render->render_path = rsvg_cairo_clip_render_path;
+    render->pop_discrete_layer = rsvg_cairo_clip_pop_discrete_layer;
+    render->push_discrete_layer = rsvg_cairo_clip_push_discrete_layer;
+    render->add_clipping_rect = rsvg_cairo_clip_add_clipping_rect;
+    render->get_surface_of_node = NULL;
+    cairo_render->initial_cr = parent->cr;
     cairo_render->cr = cr;
-    cairo_render->parent = parent;
+    clip_render->parent = parent;
 
-    return &cairo_render->super;
+    return render;
 }
 
 void
 rsvg_cairo_clip (RsvgDrawingCtx * ctx, RsvgClipPath * clip, RsvgBbox * bbox)
 {
-    RsvgCairoRender *save = (RsvgCairoRender *) ctx->render;
-    double affinesave[6];
-    int i;
+    RsvgCairoRender *save = RSVG_CAIRO_RENDER (ctx->render);
+    cairo_matrix_t affinesave;
+
     ctx->render = rsvg_cairo_clip_render_new (save->cr, save);
 
     /* Horribly dirty hack to have the bbox premultiplied to everything */
     if (clip->units == objectBoundingBox) {
-        double bbtransform[6];
-        bbtransform[0] = bbox->w;
-        bbtransform[1] = 0.;
-        bbtransform[2] = 0.;
-        bbtransform[3] = bbox->h;
-        bbtransform[4] = bbox->x;
-        bbtransform[5] = bbox->y;
-        for (i = 0; i < 6; i++)
-            affinesave[i] = clip->super.state->affine[i];
-        _rsvg_affine_multiply (clip->super.state->affine, bbtransform, clip->super.state->affine);
+        cairo_matrix_t bbtransform;
+        cairo_matrix_init (&bbtransform,
+                           bbox->rect.width,
+                           0,
+                           0,
+                           bbox->rect.height,
+                           bbox->rect.x,
+                           bbox->rect.y);
+        affinesave = clip->super.state->affine;
+        cairo_matrix_multiply (&clip->super.state->affine, &bbtransform, &clip->super.state->affine);
     }
 
     rsvg_state_push (ctx);
@@ -173,8 +164,7 @@ rsvg_cairo_clip (RsvgDrawingCtx * ctx, RsvgClipPath * clip, RsvgBbox * bbox)
     rsvg_state_pop (ctx);
 
     if (clip->units == objectBoundingBox)
-        for (i = 0; i < 6; i++)
-            clip->super.state->affine[i] = affinesave[i];
+        clip->super.state->affine = affinesave;
 
     g_free (ctx->render);
     cairo_clip (save->cr);
diff --git a/rsvg-cairo-clip.h b/rsvg-cairo-clip.h
index 61407de..f4cff9b 100644
--- a/rsvg-cairo-clip.h
+++ b/rsvg-cairo-clip.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-cairo-render.h: The cairo backend plugin
 
@@ -33,6 +34,7 @@
 
 G_BEGIN_DECLS 
 
+G_GNUC_INTERNAL
 void rsvg_cairo_clip (RsvgDrawingCtx * ctx, RsvgClipPath * clip, RsvgBbox * bbox);
 
 G_END_DECLS
